package com.bocloud.ims.interfaces.resource;

import java.util.List;
import java.util.Map;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Param;
import com.bocloud.common.model.RequestContext;

/**
 * 虚拟机模板
 * 
 * @author ymh
 * @时间 2019年3月9日
 */
public interface ServerTemplateService {

	/**
	 * 列表展示
	 *
	 * @param page
	 * @param rows
	 * @param params
	 * @param sorter
	 * @param simple
	 * @return
	 */
	public BocloudResult list(int page, int rows, List<Param> params, Map<String, String> sorter, boolean simple,
			RequestContext context);

	/**
	 * 创建
	 *
	 * @param params
	 * @param user
	 * @return
	 */
	public BocloudResult create(String params, RequestContext context);

	/**
	 * 删除
	 *
	 * @param id
	 * @param user
	 * @return
	 */
	public BocloudResult remove(Long id, RequestContext context);

	/**
	 * 详情
	 *
	 * @param id
	 * @return
	 */
	public BocloudResult detail(Long id);

	/**
	 * 修改
	 *
	 * @param bean
	 * @param userId
	 * @return
	 */
	BocloudResult modify(String params, Long userId);

	/**
	 * 修改默认版本
	 * 
	 * @param params
	 * @param userId
	 * @return
	 */
	BocloudResult modifyDafaultVersion(String params, Long userId);

	/**
	 * 删除版本号
	 * 
	 * @param params
	 * @param user
	 * @return
	 */
	BocloudResult removeTemplateVersion(String params, RequestContext context);

	/**
	 * 新建版本
	 * 
	 * @param params
	 * @param user
	 * @return
	 */
	BocloudResult createTempalteVersion(String params, RequestContext context);

}
